// (C) Copyright 2003: Reece H. Dunn 

#ifndef BOOST__IO__FORMATOB__IPP
#define BOOST__IO__FORMATOB__IPP
   template< typename T, typename FormatType, typename Outputter >
   boost::io::formatob_t< T, FormatType, Outputter >::formatob_t( const T & t ) throw():
      Outputter(),
      ob( t )
   {
   }
   template< typename T, typename FormatType, typename Outputter >
   boost::io::formatob_t< T, FormatType, Outputter >::formatob_t( const T & t, const Outputter & o ) throw():
      Outputter( o ),
      ob( t )
   {
   }
   template< typename T, typename FormatType, typename Outputter >
   boost::io::formatob_t< T, FormatType, Outputter >::formatob_t( const formatob_t & fo ) throw():
      Outputter( fo ),
      ob( fo.ob )
   {
   }

   template< typename CharT, class TraitsT, typename T, typename FormatType, typename Outputter >
   std::basic_ostream< CharT, TraitsT > & boost::io::operator<<
   (
      std::basic_ostream< CharT, TraitsT > & os,
      const boost::io::formatob_t< T, FormatType, Outputter > & fo
   )
   {
      return( fo( os, fo.ob ));
   }

   // format object generators

   template< typename T >
   inline boost::io::formatob_t< T > boost::io::formatob( const T & t )
   {
      return( boost::io::::formatob_t< T >( t ));
   }
   template< typename T, class Outputter >
   inline boost::io::formatob_t< T, char, Outputter > boost::io::formatob( const T & t, const Outputter & o )
   {
      return( boost::io::formatob_t< T, char, Outputter >( t, o ));
   }
#endif
