// (C) Copyright 2003: Reece H. Dunn 

#ifndef BOOST__IO__FORMAT_OBJECTS__PAIR_OUTPUT__IPP
#define BOOST__IO__FORMAT_OBJECTS__PAIR_OUTPUT__IPP
   template< typename FormatType, typename Outputter1, typename Outputter2 >
   boost::io::pair_output< FormatType, Outputter1, Outputter2 >::pair_output() throw()
   {
   }
   template< typename FormatType, typename Outputter1, typename Outputter2 >
   boost::io::pair_output< FormatType, Outputter1, Outputter2 >::pair_output( const Outputter1 & o1 ) throw():
      firstout( o1 )
   {
   }
   template< typename FormatType, typename Outputter1, typename Outputter2 >
   boost::io::pair_output< FormatType, Outputter1, Outputter2 >::pair_output( const Outputter1 & o1, const Outputter2 & o2 ) throw():
      firstout(  o1 ),
      secondout( o2 )
   {
   }
   template< typename FormatType, typename Outputter1, typename Outputter2 >
   boost::io::pair_output< FormatType, Outputter1, Outputter2 >::pair_output( const pair_output & o ) throw():
      formatter_t< FormatType, pair_output >( o ),
      firstout(  o.firstout  ),
      secondout( o.secondout )
   {
   }

   // pair_output generators

   boost::io::pair_output< char > boost::io::pairfmt()
   {
      return( boost::io::pair_output< char >());
   }

   template< typename FormatType >
   boost::io::pair_output< FormatType > boost::io::pairfmtex()
   {
      return( boost::io::pair_output< FormatType >());
   }
#endif
